stages:
 - build
 - package
 - deploy

build:
  stage: build
  image: node:latest
  only:
    - master
  script:
    - npm install
    - ng run build 
  artifacts:
    paths:
      - dist/
    expire_in: 2 hours
  cache:
    paths:
      - node_modules/
docker-build:
# Official docker image.
 image: docker:stable
 only :
  - master
 stage: package
 services:
  - docker:dind
 before_script:
  - echo $CI_BUILD_TOKEN | docker login -u "$CI_REGISTRY_USER" 
    --password-stdin $CI_REGISTRY
 script:
  - IMAGE_NAME="$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME"
  - docker build --pull -t "$IMAGE_NAME" -f Dockerfile .
  - docker push "$IMAGE_NAME"
ansible-deploy:   
  stage: deploy
  image: mullnerz/ansible-playbook:2.9.1
  only : 
    - master    
  before_script: 
  #generate ssh key   
    - mkdir -p ~/.ssh     
    - echo -e "$SSH_PRIVATE_KEY" > ~/.ssh/id_rsa     
    - chmod 600 ~/.ssh/id_rsa     
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'   
    - export IMAGE_NAME="$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME"
    - export DEPLOY_TARGET=prod
    - cd ansible
  script:
    - chmod -v 700 $(pwd)      
    - ansible-playbook --key-file ~/.ssh/id_rsa  playbook.yml